*!Ŀ
*!                     NG KHAI DEVELOPMENT CORP.                       
*!             Computer Consultancy * Software Development             
*! 				              Import * Export                       
*!               FAX : 63-32-86241       73751.1012@Compuserve.com     
*!		               Hernan Cortes St., Banilad                       
*!                        Mandaue City, Cebu                           
*!                         6014 Philippines                            
*!Ĵ
*!                                                                     
*!  AUTHOR       : Ronaldo M. Sering                                   
*!  DATE 		   : March 19, 1994                                     
*!  DESCRIPTION  : This program provides a variety of restore utitities
*!                 for users.                                          
*!                                                                     
*!  MODIFICATION LOG :                                                 
*!                                                                     
*!      WHO  :                                                         
*!      WHEN :                                                         
*!      WHY  :                                                         
*!                                                                     
*!
SET EXCLUSIVE ON
SET TALK OFF
*
* Check wether drive/paths information for backup
* files exist. If not, provide an error message
* and return to the calling program.
*
IF FILE("BAREDIR.DBF")
	IF USED('baredir')
		SELECT baredir
	ELSE
		SELECT 0
		USE baredir
	ENDIF	
ELSE
	=DIALOG("Drive\Paths information for backup files not found.;Cannot do restore.",7,"\<OK")
	RETURN
ENDIF		

*
* Check information about backup ( the day of the backup, 
* type of backup, etc;) If it does not exist provides an 
* error message and return to the calling.
*
IF FILE("BACKUP.DBF")
	IF USED('backup')
		SELECT backup
		SET ORDER TO TAG "backtday"
	ELSE
		SELECT 0
		USE backup ORDER TAG "backtday"
	ENDIF
ELSE
	=DIALOG("Backup files information not found.; Cannot do restore.",7,"\<OK")
	RETURN
ENDIF

SET PROCEDURE TO TOOLS

*       ķ
*                                                                
*                           Window definitions                   
*                                                                
*       Ľ
IF NOT WEXIST("restorewin")
	DEFINE WINDOW restorewin ;
		FROM INT((SROW()-24)/2),INT((SCOL()-60)/2) ;
		TO INT((SROW()-24)/2)+24,INT((SCOL()-60)/2)+59 ;
		TITLE "[ RESTORE WINDOW ]" ;
		FLOAT ;
		CLOSE ;
		SHADOW ;
		MINIMIZE ;
		ZOOM ;
		GROW ;
		SYSTEM ;
		COLOR SCHEME 1
ENDIF
*       ķ
*                                                                
*                        RESTCOPY Screen Layout                  
*                                                                
*       Ľ
IF WVISIBLE("restorewin")
	ACTIVATE WINDOW restorewin SAME
ELSE
	ACTIVATE WINDOW restorewin NOSHOW
ENDIF

@ 3,5 SAY "COMMAND :"
@ 10,3 TO 17,20
@ 10,21 TO 17,54
@ 9,2 TO 18,55
@ 9,4 SAY "[ RESTORE FROM ]"
@ 1,2 TO 8,55
@ 1,4 SAY "[ RESTORE TYPE ]"
@ 5,3 TO 7,54
@ 2,3 TO 4,54
@ 19,2 TO 21,55
@ 19,4 SAY "[ ACTION ]"

m.BInfo    = LASTBACKUP()		&& Get information about last backup
m.BackType = SPACE(10)
m.BackDay  = 0
m.CurDir   = SYS(5)+CURDIR()
m.Dest     = ""
m.ComLine  = ""
m.RestType   = 0
m.DayRestore = 0

SELECT baredir
SCATTER MEMVAR

= SetDefaults() 

@ 3,15 GET m.ComLine ;
	SIZE 1,38 ;
	DEFAULT " " ;
	PICTURE "@!K" ;
	VALID _VCommandLine()
@ 6,7 GET m.RestType ;
	PICTURE "@*RHN \<Restore;\<Copy;\<Pkunzip" ;
	SIZE 1,15,0 ;
	DEFAULT 1 ;
	VALID _VRestType()
@ 11,5 GET m.DayRestore ;
	PICTURE "@*RVN \<Monday;\<Tuesday;\<Wednesday;T\<hursday;\<Friday;\<Saturday" ;
	SIZE 1,13,0 ;
	DEFAULT 1 
@ 11,23 GET m.Monday ;
	SIZE 1,30 ;
	DEFAULT " " ;
	WHEN .F. ;
	PICTURE "@!K"
@ 12,23 GET m.Tuesday ;
	SIZE 1,30 ;
	DEFAULT " " ;
	WHEN .F. ;
	PICTURE "@!K"
@ 13,23 GET m.Wednesday ;
	SIZE 1,30 ;
	DEFAULT " " ;
	WHEN .F. ;
	PICTURE "@!K"
@ 14,23 GET m.Thursday ;
	SIZE 1,30 ;
	DEFAULT " " ;
	WHEN .F. ;
	PICTURE "@!K"
@ 15,23 GET m.Friday ;
	SIZE 1,30 ;
	DEFAULT " " ;
	WHEN .F. ;
	PICTURE "@!K"
@ 16,23 GET m.Saturday ;
	SIZE 1,30 ;
	DEFAULT " " ;
	WHEN .F. ;
	PICTURE "@!K"
@ 20,5 GET m.RestEvent ;
	PICTURE "@*HN Restore \<Now;\<Exit" ;
	SIZE 1,16,8 ;
	DEFAULT 1 ;
	VALID _VRestEvent()

IF NOT WVISIBLE("restorewin")
	ACTIVATE WINDOW restorewin
ENDIF

READ CYCLE DEACTIVATE _VWClose("restorewin")

RELEASE WINDOW restorewin
CLOSE DATA
SET EXCLUSIVE OFF
RETURN


*!Ŀ
*!                  VALIDATE COMMAND LINE                     
*!
FUNCTION _VCommandLine
*begin
	IF NOT EMPTY(m.ComLine)
		SHOW GET m.RestType DISABLE
		SHOW GET m.DayRestore  DISABLE
	ELSE	
		SHOW GET m.RestType ENABLE
		SHOW GET m.DayRestore  ENABLE
	ENDIF
	RETURN .T.
*end
*!Ŀ
*!                                                            
*!
FUNCTION _VRestType
*begin
	_CUROBJ = OBJNUM(m.DayRestore)
	RETURN .T.
*end
*!Ŀ
*!                                                            
*!
FUNCTION _VRestEvent
*begin
	IF NOT EMPTY(m.ComLine)
		m.BackType = "COMMAND"
	ELSE	
		DO CASE
			CASE m.RestType = 1
				m.BackType = "BACKUP"
			CASE m.RestType = 2
				m.BackType = "COPY"
			CASE m.RestType = 3
				m.BackType = "PKZIP"
		ENDCASE
	ENDIF
	m.BackDay = m.DayRestore
	DO CASE 
		CASE m.RestEvent = 1				&& 	Restore backup

			IF USED("backup")
				SELECT backup
				SET ORDER TO TAG "backtday"
			ELSE
				SELECT 0
				USE backup ORDER TAG "backtday"
			ENDIF	
			
			IF NOT SEEK(PADR(m.BackType,10)+STR(m.BackDay),"backup")
				= DIALOG("Backup information not found. Cannot do restore.",7,"\<OK")
				RETURN 0
			ENDIF
			DO RestoreIt
		CASE m.RestEvent = 2				&&		Quit Restore	
			CLEAR READ
	ENDCASE
	RETURN .T.
*end
*!Ŀ
*!                                                            
*!
PROCEDURE RestoreIt
*begin
	DO CASE
		CASE m.DayRestore = 1
			m.Dest = m.Monday
		CASE m.DayRestore = 2
			m.Dest = m.Tuesday
		CASE m.DayRestore = 3
			m.Dest = m.Wednesday
		CASE m.DayRestore = 4
			m.Dest = m.Thursday
		CASE m.DayRestore = 5
			m.Dest = m.Friday
		CASE m.DayRestore = 6
			m.Dest = m.Saturday
	ENDCASE
	
	m.Dest = ALLT(m.Dest)
	IF DIREXIST(m.Dest)
	
		CLOSE DATABASES
		DO CASE
			CASE m.BackType = "COMMAND"
				RUN &ComLine
			CASE m.BackType = "BACKUP"
				m.CurDir = m.CurDir
				m.Dest   = LEFT(ALLT(m.Dest),2)
				mess = "Make sure that RESTORE.EXE exist in correct path."
				IF DIALOG(mess,7,"\!\<OK ; \<Cancel") = 1
					pcCommand = "RUN RESTORE "+m.Dest+" "+m.CurDir
					&pcCommand
				ENDIF	
			CASE m.BackType = "COPY"
				m.CurDir = UPPER(m.CurDir)
				m.Dest   = ALLT(m.Dest)
				IF ALLT(m.CurDir) = UPPER(m.Dest)
					= DIALOG("Cannot do restore to the same drive and path.",7,"\<OK")
					RETURN 0
				ENDIF
				IF LEFT(m.Dest,1) $ "AB"
					= DIALOG("Cannot do restore from that drive. Please use other RESTORE utility.",7,"\<OK")
				ELSE	
					DO RESTORENOW
				ENDIF	
			CASE m.BackType = "PKZIP"
				m.CurDir = m.CurDir +"*.*"
				m.Dest   = ADDBS(ALLT(m.Dest))+ "BACKUP01.ZIP"
				mess = "Make sure that PKUNZIP.EXE exist in correct path."
				IF DIALOG(mess,7,"\!\<OK ; \<Cancel") = 1
					pcCommand = "RUN PKUNZIP "+m.Dest
					&pcCommand
				ENDIF	
		ENDCASE
	ELSE
		=DIALOG("Directory/Path does not exist.;Cannot do BACKUP.",7,"\<OK")
		RETURN 0
	ENDIF	
*end
*!Ŀ
*!                                                            
*!
PROCEDURE RESTORENOW
*begin
*
* Get all necessary file to be backed up
* using the copyfile user defined function(udf).
*
DIMENSION pcDBFfiles(1)
DIMENSION pcCDXfiles(1)
DIMENSION pcFPTfiles(1)

= ADIR( pcDBFfiles, ADDBS(m.Dest) + "*.DBF")		&& Get all database files
= ADIR( pcCDXfiles, ADDBS(m.Dest) + "*.CDX")		&& Get all index files
= ADIR( pcFPTfiles, ADDBS(m.Dest) + "*.FPT")		&& Get all memo files

IF TYPE("pcDBFfiles") = "L" AND ;
	TYPE("pcDBFfiles") = "L" AND ;
	TYPE("pcDBFfiles") = "L"
	=DIALOG("No files found to be restored. Cannot do restore",7,"\<OK")
	RETURN
ENDIF	
*
* Determine the total number of files to be restored.
*
pnTotDBF = ALEN(pcDBFfiles,1)			&& Total DBF files
pnTotCDX = ALEN(pcCDXfiles,1)			&& Total CDX files
pnTotFPT = ALEN(pcFPTfiles,1)			&& Total FPT files
*
* Determine the total size of all files to be backed up.
*
IF NOT TYPE("pcDBFfiles") = "L"
	pnTotSize = 0								&& Total size of all DBF files
	FOR I = 1 TO pnTotDBF
		pnTotSize = pnTotSize + pcDBFfiles[I,2]
	ENDFOR
ELSE
	pnTotDBF = 0
ENDIF	

IF NOT TYPE("pcCDXfiles") = "L"		&& If CDX files are found get the total size of all
	FOR I = 1 TO pnTotCDX
		pnTotSize = pnTotSize + pcCDXfiles[I,2]
	ENDFOR	
ELSE
	pnTotCDX = 0	
ENDIF

IF NOT TYPE("pcFPTfiles") = "L"		&& If FPT files are found get the total size of all
	FOR I = 1 TO pnTotFPT
		pnTotSize = pnTotSize + pcFPTfiles[I,2]
	ENDFOR
ELSE
	pnTotFPT = 0	
ENDIF

=ACTTHERM("")				&& activate thermometer

pnCurPercent = 0			&& Percent finished

mess = "Copying TABLES : "+pcDBFfiles[1,1]+" FROM "+m.Dest+pcDBFfiles[1,1]
= UPDTHERM(2,mess)

plIgnorAll = .F.				&& Ignore all error encountered while copying.
PlCancel   = .F.           && User interrupted or cancelled operation.

FOR I = 1 TO pnTotDBF

	mess = "Copying TABLES : "+pcDBFfiles[I,1]+" FROM "+m.Dest+pcDBFfiles[I,1]
	pnCurPercent = pnCurPercent + ((pcDBFfiles[I,2]/pnTotSize)*100)
   pnExist = 0
	
	*
	* Copy the file now.
	*
	pnErrNo = COPYFILE(m.Dest+pcDBFfiles[I,1],ADDBS(JUSTPATH(m.CurDir))+pcDBFfiles[I,1])
	
	*
	* Ask the user what action to take if 
	* an error occurs while copying
	*
	pnAction = 0
	IF NOT plIgnorAll
		IF pnErrNo > 0
			errmess = RETFERROR( pnErrNo )
			pnAction = DIALOG(errmess,7,"\?\<Cancel ;\<Ignore ;Ignore \<All")
			DO CASE
				CASE pnAction = 1			&& Cancel
					plCancel = .T.
					EXIT
				CASE pnAction = 2			&& Ignore
					LOOP
				CASE pnAction = 3			&& Ignore All
					plIgnorAll = .T.
			ENDCASE
		ENDIF	
	ENDIF
	= UPDTHERM(pnCurPercent,mess)

ENDFOR

IF NOT plCancel
	IF pnTotCDX > 0
		FOR I = 1 TO pnTotCDX
			mess = "Copying INDEXES : "+pcCDXfiles[I,1]+" FROM "+m.Dest+pcCDXfiles[I,1]
			pnCurPercent = pnCurPercent + ((pcCDXfiles[I,2]/pnTotSize)*100)
	   	pnExist = 0
	
			*
			* Copy the file now.
			*
			pnErrNo = COPYFILE(m.Dest+pcCDXfiles[I,1],ADDBS(JUSTPATH(m.CurDir))+pcCDXfiles[I,1])
	
			*
			* Ask the user what action to take if 
			* an error occurs while copying
			*
			pnAction = 0
			IF NOT plIgnorAll
				IF pnErrNo > 0
					errmess = RETFERROR( pnErrNo )
					pnAction = DIALOG(errmess,7,"\?\<Cancel ;\<Ignore ;Ignore \<All")
					DO CASE
						CASE pnAction = 1			&& Cancel
							plCancel = .T.
							EXIT
						CASE pnAction = 2			&& Ignore
							LOOP
						CASE pnAction = 3			&& Ignore All
							plIgnorAll = .T.
					ENDCASE
				ENDIF	
			ENDIF
			= UPDTHERM(pnCurPercent,mess)
		ENDFOR
	ENDIF
ENDIF	

IF NOT plCancel
	IF pnTotFPT > 0
		FOR I = 1 TO pnTotFPT

			mess = "Copying MEMO : "+pcFPTfiles[I,1]+" FROM "+m.Dest+pcFPTfiles[I,1]
			pnCurPercent = pnCurPercent + ((pcFPTfiles[I,2]/pnTotSize)*100)
	   	pnExist = 0
	
			*
			* Copy the file now.
			*
			pnErrNo = COPYFILE(m.Dest+pcFPTfiles[I,1],ADDBS(JUSTPATH(m.CurDir))+pcFPTfiles[I,1])
	
			*
			* Ask the user what action to take if 
			* an error occurs while copying
			*
			pnAction = 0
			IF NOT plIgnorAll
				IF pnErrNo > 0
					errmess = RETFERROR( pnErrNo )
					pnAction = DIALOG(errmess,7,"\?\<Cancel ;\<Ignore ;Ignore \<All")
					DO CASE
						CASE pnAction = 1			&& Cancel
							EXIT
						CASE pnAction = 2			&& Ignore
							LOOP
						CASE pnAction = 3			&& Ignore All
							plIgnorAll = .T.
					ENDCASE
				ENDIF	
			ENDIF
			= UPDTHERM(pnCurPercent,mess)

		ENDFOR
	ENDIF
ENDIF
	
= UPDTHERM(100,mess)
= DEACTTHERM()
*end
*!Ŀ
*!  FUNCTIONS : Terminate read if window isn't visible.       
*!
FUNCTION _VWClose
PARAMETER pcWindName
*begin
	PRIVATE pcWindName
	IF WVISIBLE(pcWindName)
		RETURN .F.
	ELSE
		RETURN .T.
	ENDIF
*end
*!Ŀ
*!                                                            
*!
* This function determines the latest
* date of backup, the type of backup
* used and the day of the backup.
*
FUNCTION LASTBACKUP
*begin
PRIVATE pnDayType

IF USED('backup')
	SELECT BACKUP
ELSE	
	SELECT 0
	USE BACKUP
ENDIF

SELECT backdate, ;
       backtype, ;
       backday ;
 	FROM backup ;
 	INTO CURSOR SAMPLE ;
 	GROUP by backday, backtype ;
 	ORDER BY backdate

SET FILTER TO backday < DOW(DATE())
GO BOTTOM
IF EOF()
	SET FILTER TO 
	GO BOTTOM
ENDIF

pnDayType = ALLT(backtype) + ALLT(STR(backday))
USE

RETURN pnDayType
*end 	      
*!Ŀ
*! Sets default settings of RESTORE                           
*!
FUNCTION SETDEFAULTS
*begin
	PRIVATE pcBInfo
	m.DayRestore = VAL(RIGHT(m.BInfo,1))
	pcBInfo = LEFT(m.BInfo,LEN(m.BInfo) - 1)
	DO CASE
		CASE pcBInfo = "COMMAND" 
			SHOW GET m.RestType DISABLE
			SHOW GET m.DayRestore  DISABLE
		CASE pcBInfo = "BACKUP" 
			m.RestType = 1
		CASE pcBInfo = "COPY" 
			m.RestType = 2
		CASE pcBInfo = "PKZIP" 
			m.RestType = 3
	ENDCASE
	RETURN .T.
*end
